/* Name: main.c
 
 */
#define F_CPU 12800000
#include <avr/io.h>
#include <avr/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>

#include "usbconfig.h"
#include "usbdrv/usbdrv.h"
#include "osccal.h"
#include "osccal.c"

void delay_ms(unsigned num){
        while (num--) _delay_ms(0.96);
}

unsigned char pinlevels[3];
unsigned char pinfade[3];

int main(void){
	unsigned char j=0; unsigned char i=0;
	DDRB=255;
	DDRC=255;
	//OSCCAL=249;
	CLKPR=0x80;
	CLKPR=0;
	//PRR&=~_BV(PRADC);
	sei();
	usbInit();

	
	while (1){
		if(i==0){
			j++;
			if (j==0){
				usbPoll();
				if (pinfade[0]) pinlevels[0]++;
				if (pinfade[1]) pinlevels[1]++;
				if (pinfade[2]) pinlevels[2]++;
				
			}
		}
		i++;
		PORTC=(
			  ((pinlevels[0]<i)?0:_BV(0))
			| ((pinlevels[1]<i)?0:_BV(1))
                        | ((pinlevels[2]<i)?0:_BV(2))
		);

		
	}
}


struct inData{
	unsigned char r:5;
	unsigned char g:5;
	unsigned char b:5;
	unsigned char pad:1;
}	;

uchar	usbFunctionSetup(uchar data[8]){
	usbRequest_t    *rq = (void *)data;
	static uchar    replyBuf[3];

    	usbMsgPtr = replyBuf;
    	if(rq->bRequest == 0){  /* ECHO */
        	replyBuf[0] = rq->wValue.bytes[0];
        	replyBuf[1] = rq->wValue.bytes[1];
       		return 2;
    	}
    	if(rq->bRequest == 1){  /* Set Output Pins*/
        	PORTB=rq->wValue.bytes[0];
		return 0;
    	}
	if(rq->bRequest == 10){
		struct inData *d=(void *)rq->wValue.bytes;
		pinlevels[0]=d->r*8;
		pinlevels[1]=d->g*8;
		pinlevels[2]=d->b*8;
		
		replyBuf[0]=pinlevels[0];
		replyBuf[1]=pinlevels[1];
		replyBuf[2]=pinlevels[2];
		return 3;
	}
	if (rq->bRequest == 20){
		pinfade[0]=rq->wValue.bytes[0]&1;
		pinfade[1]=rq->wValue.bytes[0]&2;
		pinfade[2]=rq->wValue.bytes[0]&4;
	}
	return 0;
}

void    usbEventResetReady(void){	
    calibrateOscillator();
}
